/*
 * 2014/12 made by audin
 * http://mpu.seesaa.net
 *
 */
#ifndef SYS_H_INCLUDED
#define SYS_H_INCLUDED
#include "mips16.h"
#ifdef __XC32
#include <xc.h>          /* Defines special funciton registers, CP0 regs  */
#endif

#include <plib.h>           /* Include to use PIC32 peripheral libraries      */
#include <stdint.h>         /* For uint32_t definition                        */
#include <stdbool.h>        /* For true/false definition                      */


#if defined (__32MX220F032B__) || defined (__32MX250F128B__)
#define FOSC (48000000L)
#endif
#define	GetPeripheralClock()		(FOSC/(1 << OSCCONbits.PBDIV))
#define	GetInstructionClock()		(GetSystemClock())


#endif   /* SYS.H_INCLUDED */
