/*------------------------------------------------------------------------*/
/* Universal string handler for user console interface  (C)ChaN, 2011     */
/*------------------------------------------------------------------------*/

#ifndef _STRFUNC
#define _STRFUNC

#include "mips16.h"

#define _USE_XFUNC_OUT	1	/* 1: Use output functions */
#define	_CR_CRLF		1	/* 1: Convert \n ==> \r\n in the output char */

#define _USE_XFUNC_IN	0	/* 1: Use input function */
#define	_LINE_ECHO		0	/* 1: Echo back input chars in xgets function */


#if _USE_XFUNC_OUT
#define xdev_out(func) xfunc_out = (void(*)(unsigned char))(func)
extern void (*xfunc_out)(unsigned char);
void _MIPS16 xputc (char c);
void _MIPS16 xputs (const char* str);
void _MIPS16 xfputs (void (*func)(unsigned char), const char* str);
void _MIPS16 xprintf (const char* fmt, ...);
void _MIPS16 xsprintf (char* buff, const char* fmt, ...);
void _MIPS16 xfprintf (void (*func)(unsigned char), const char*	fmt, ...);
void _MIPS16 put_dump (const void* buff, unsigned long addr, int len, int width);
#define DW_CHAR		sizeof(char)
#define DW_SHORT	sizeof(short)
#define DW_LONG		sizeof(long)
#endif

#if _USE_XFUNC_IN
#define xdev_in(func) xfunc_in = (unsigned char(*)(void))(func)
extern unsigned char (*xfunc_in)(void);
int _MIPS16 xgets (char* buff, int len);
int _MIPS16 xfgets (unsigned char (*func)(void), char* buff, int len);
int _MIPS16 xatoi (char** str, long* res);
#endif

#endif
